/*
 * adc.c
 *
 * Created: 24.02.2019 21:32:54
 *  Author: Chris
 */ 

#include "adc.h"


uint16_t adc_read(adc_ref_e reference, adc_mux_e channel, uint8_t avgcnt)
{
	ADMUX = reference | (0<<ADLAR) | channel;
	// 12 MHz / 200 kHz = 60 => 187.5 kHz ADC clk
	ADCSRA = (1<<ADEN) | (0<<ADIE) | adc_clkdiv_64;
	
	// the first measurement may be inaccurate, discard.
	ADCSRA |= (1<<ADSC);
	while(ADCSRA & (1<<ADSC));
	
	uint16_t tmp = 0;
	for(uint8_t i = 0; i < avgcnt; i++)
	{
		ADCSRA |= (1<<ADSC);
		while(ADCSRA & (1<<ADSC));
		tmp += ADC;
	}
	
	ADCSRA &= ~(1<<ADEN);
	return tmp;
}