/*
 * config.h
 *
 * Created: 03.02.2019 21:51:37
 *  Author: Chris
 */ 


#ifndef CONFIG_H_
#define CONFIG_H_

#include "simpleio.h"

#define PIROZEDA_VERSION "0.2"

// show "kitty messages" (PROZEDA_IGNORE_KITTY must be enabled as well)
//#define PIROZEDA_KITTY_DEBUG

// show timestamps
//#define PIROZEDA_TIMESTAMPS


// data received LED
#define STATUS0 IOPIN(D, 6)

// MCU active LED
#define STATUS1 IOPIN(D, 5)

#define SPI_MISO IOPIN(B, 4)
#define SPI_CS IOPIN(B, 2)

// timeout of the watchdog, just the values from avr/wdt.h
// when messages are successfully received, the watchdog is being reset
// therefore only the following timeouts really make sense: 
// WDTO_1S WDTO_2S WDTO_4S WDTO_8S
#define PIROZEDA_WDT_TIMEOUT WDTO_4S

// enable uptime counter
#define PIROZEDA_UPTIME

// maximum: 32
#define PIROZEDA_SUPPLY_AVGCNT 10

// amount of header messages to be sent after startup
#define PIROZEDA_HEADERCNT 200

// on-time of the status-led after bootup, step size is 2.5 ms
#define PIROZEDA_STATUS_LED_BOOT 100

// on-time of the status-led for received messages, step size is 2.5 ms
#define PIROZEDA_STATUS_LED_RXOK 4

// on-time of the status-led for errors, step size is 2.5 ms
#define PIROZEDA_STATUS_LED_RXERR 80

// bootloader password, must be 4 characters
#define BOOTLOADER_PASSWORD "FwUp"

// for more config, see prozeda_cfg.h!


#if PIROZEDA_WDT_TIMEOUT == WDTO_1S
#define PIROZEDA_WDT_TIMEOUT_TEXT "1 s"
#elif PIROZEDA_WDT_TIMEOUT == WDTO_2S
#define PIROZEDA_WDT_TIMEOUT_TEXT "2 s"
#elif PIROZEDA_WDT_TIMEOUT == WDTO_4S
#define PIROZEDA_WDT_TIMEOUT_TEXT "4 s"
#elif PIROZEDA_WDT_TIMEOUT == WDTO_8S
#define PIROZEDA_WDT_TIMEOUT_TEXT "8 s"
#endif


#define statusled_rxok() statusled_set(PIROZEDA_STATUS_LED_RXOK)
#define statusled_rxerr() statusled_set(PIROZEDA_STATUS_LED_RXERR)


#endif /* CONFIG_H_ */