/*
 * m328p.h
 *
 * Created: 12.01.2017 20:27:12
 *  Author: Chris
 */ 


#ifndef M328P_H_
#define M328P_H_

#include <avr/io.h>

typedef enum
{
	timer0_prescaler_off    = (0<<CS02) | (0<<CS01) | (0<<CS00),
	timer0_prescaler_1      = (0<<CS02) | (0<<CS01) | (1<<CS00),
	timer0_prescaler_8      = (0<<CS02) | (1<<CS01) | (0<<CS00),
	timer0_prescaler_64     = (0<<CS02) | (1<<CS01) | (1<<CS00),
	timer0_prescaler_256    = (1<<CS02) | (0<<CS01) | (0<<CS00),
	timer0_prescaler_1024   = (1<<CS02) | (0<<CS01) | (1<<CS00),
	timer0_prescaler_T0fall = (1<<CS02) | (1<<CS01) | (0<<CS00),
	timer0_prescaler_T0rise = (1<<CS02) | (1<<CS01) | (1<<CS00),
}	timer0_prescaler_t;

typedef enum
{
	timer0a_wgm_normal    = (0<<WGM01) | (0<<WGM00), //< Normal
	timer0a_wgm_pwmPc0    = (0<<WGM01) | (1<<WGM00), //< PWM, Phase correct, Top: 0xFF, Update: Top
	timer0a_wgm_ctc       = (1<<WGM01) | (0<<WGM00), //< CTC, Top: OCRA, Update: Immediate
	timer0a_wgm_pwmFast0  = (1<<WGM01) | (1<<WGM00), //< Fast PWM, Top: 0xFF, Update: Bottom
	timer0a_wgm_reserved0 = (0<<WGM01) | (0<<WGM00),
	timer0a_wgm_pwmPc1    = (0<<WGM01) | (1<<WGM00), //< PWM, Phase correct, Top: PCRA, Update: Top
	timer0a_wgm_reserved1 = (1<<WGM01) | (0<<WGM00),
	timer0a_wgm_pwmFast1  = (1<<WGM01) | (1<<WGM00), //< Fast PWM, Top: OCRA, Update: Bottom
}	timer0a_wgm_t;


typedef enum
{
	timer0b_wgm_normal    = (0<<WGM02), //< Normal
	timer0b_wgm_pwmPc0    = (0<<WGM02), //< PWM, Phase correct, Top: 0xFF, Update: Top
	timer0b_wgm_ctc       = (0<<WGM02), //< CTC, Top: OCRA, Update: Immediate
	timer0b_wgm_pwmFast0  = (0<<WGM02), //< Fast PWM, Top: 0xFF, Update: Bottom
	timer0b_wgm_reserved0 = (1<<WGM02),
	timer0b_wgm_pwmPc1    = (1<<WGM02), //< PWM, Phase correct, Top: PCRA, Update: Top
	timer0b_wgm_reserved1 = (1<<WGM02),
	timer0b_wgm_pwmFast1  = (1<<WGM02), //< Fast PWM, Top: OCRA, Update: Bottom
}	timer0b_wgm_t;

typedef enum
{
	timer1a_coma_bm    = (1<<COM1A1) | (1<<COM1A0),
	
	timer1a_coma_normal = (0<<COM1A1) | (0<<COM1A0),
	timer1a_coma_toggle = (0<<COM1A1) | (1<<COM1A0),
	timer1a_coma_clear  = (1<<COM1A1) | (0<<COM1A0),
	timer1a_coma_set    = (1<<COM1A1) | (1<<COM1A0),
}	timer1a_coma_t;

typedef enum
{
	timer1a_comb_bm     = (1<<COM1B1) | (1<<COM1B0),
	
	timer1a_comb_normal = (0<<COM1B1) | (0<<COM1B0),
	timer1a_comb_toggle = (0<<COM1B1) | (1<<COM1B0),
	timer1a_comb_clear  = (1<<COM1B1) | (0<<COM1B0),
	timer1a_comb_set    = (1<<COM1B1) | (1<<COM1B0),
}	timer1a_comb_t;

typedef enum
{
	timer1a_wgm_0_Normal =    (0<<WGM11) | (0<<WGM10),
	timer1a_wgm_1_PwmPc8 =    (0<<WGM11) | (1<<WGM10),
	timer1a_wgm_2_PwmPc9 =    (1<<WGM11) | (0<<WGM10),
	timer1a_wgm_3_PwmPc10 =   (1<<WGM11) | (1<<WGM10),
	timer1a_wgm_4_CTCOcr1a =  (0<<WGM11) | (0<<WGM10),
	timer1a_wgm_5_PwmF8 =     (0<<WGM11) | (1<<WGM10),
	timer1a_wgm_6_PwmF9 =     (1<<WGM11) | (0<<WGM10),
	timer1a_wgm_7_PwmF10 =    (1<<WGM11) | (1<<WGM10),
	timer1a_wgm_8_PwmPFC1 =   (0<<WGM11) | (0<<WGM10),
	timer1a_wgm_9_PwmPFC2 =   (0<<WGM11) | (1<<WGM10),
	timer1a_wgm_A_PwmPC1 =    (1<<WGM11) | (0<<WGM10),
	timer1a_wgm_B_PwmPC2 =    (1<<WGM11) | (1<<WGM10),
	timer1a_wgm_C_CTCIcr1 =   (0<<WGM11) | (0<<WGM10),
	timer1a_wgm_D_Reserved0 = (0<<WGM11) | (1<<WGM10),
	timer1a_wgm_E_PwmFIcr1  = (1<<WGM11) | (0<<WGM10),
	timer1a_wgm_F_PwmFcr1a  = (1<<WGM11) | (1<<WGM10),
}	timer1a_wgm_t;

typedef enum
{
	timer1b_wgm_0_Normal =    (0<<WGM13) | (0<<WGM12),
	timer1b_wgm_1_PwmPc8 =    (0<<WGM13) | (0<<WGM12),
	timer1b_wgm_2_PwmPc9 =    (0<<WGM13) | (0<<WGM12),
	timer1b_wgm_3_PwmPc10 =   (0<<WGM13) | (0<<WGM12),
	timer1b_wgm_4_CTCOcr1a =  (0<<WGM13) | (1<<WGM12),
	timer1b_wgm_5_PwmF8 =     (0<<WGM13) | (1<<WGM12),
	timer1b_wgm_6_PwmF9 =     (0<<WGM13) | (1<<WGM12),
	timer1b_wgm_7_PwmF10 =    (0<<WGM13) | (1<<WGM12),
	timer1b_wgm_8_PwmPFC1 =   (1<<WGM13) | (0<<WGM12),
	timer1b_wgm_9_PwmPFC2 =   (1<<WGM13) | (0<<WGM12),
	timer1b_wgm_A_PwmPC1 =    (1<<WGM13) | (0<<WGM12),
	timer1b_wgm_B_PwmPC2 =    (1<<WGM13) | (0<<WGM12),
	timer1b_wgm_C_CTCIcr1 =   (1<<WGM13) | (1<<WGM12),
	timer1b_wgm_D_Reserved0 = (1<<WGM13) | (1<<WGM12),
	timer1b_wgm_E_PwmFIcr1  = (1<<WGM13) | (1<<WGM12),
	timer1b_wgm_F_PwmFcr1a  = (1<<WGM13) | (1<<WGM12),
}	timer1b_wgm_t;

typedef enum
{
	timer1b_clkdiv_off  = (0<<CS12) | (0<<CS11) | (0<<CS10),
	timer1b_clkdiv_1    = (0<<CS12) | (0<<CS11) | (1<<CS10),
	timer1b_clkdiv_8    = (0<<CS12) | (1<<CS11) | (0<<CS10),
	timer1b_clkdiv_64   = (0<<CS12) | (1<<CS11) | (1<<CS10),
	timer1b_clkdiv_256  = (1<<CS12) | (0<<CS11) | (0<<CS10),
	timer1b_clkdiv_1024 = (1<<CS12) | (0<<CS11) | (1<<CS10),
	timer1b_clkdiv_T1f  = (1<<CS12) | (1<<CS11) | (0<<CS10),
	timer1b_clkdiv_T1r  = (1<<CS12) | (1<<CS11) | (1<<CS10),
}	timer1b_clkdiv_t;

//////////////////////////////////////////////////////////////////////////
// ADC
//////////////////////////////////////////////////////////////////////////

#define ADC_MAX 1023
#define ADC_REF_1V1 1.1


// Register: ADMUX
typedef enum
{
	adc_ref_bm       = (1<<REFS1) | (1<<REFS0),
	
	adc_ref_Aref     = (0<<REFS1) | (0<<REFS0),
	adc_ref_AVcc     = (0<<REFS1) | (1<<REFS0),
	adc_ref_Reserved = (1<<REFS1) | (0<<REFS0),
	adc_ref_Int1V1   = (1<<REFS1) | (1<<REFS0),
}	adc_ref_e;

// Register: ADMUX
typedef enum
{
	adc_mux_bm = 0xF,
	
	adc_mux_Adc0 = 0,
	adc_mux_Adc1 = 1,
	adc_mux_Adc2 = 2,
	adc_mux_Adc3 = 3,
	adc_mux_Adc4 = 4,
	adc_mux_Adc5 = 5,
	adc_mux_Adc6 = 6,
	adc_mux_Adc7 = 7,
	adc_mux_Temp = 8,
	adc_mux_1V1  = 14,
	adc_mux_GND  = 15,
}	adc_mux_e;

// Register: ADCSRA
typedef enum
{
	adc_clkdiv_bm =  (1<<ADPS2) | (1<<ADPS1) | (1<<ADPS0),
	
	adc_clkdiv_2a =  (0<<ADPS2) | (0<<ADPS1) | (0<<ADPS0),
	adc_clkdiv_2b =  (0<<ADPS2) | (0<<ADPS1) | (1<<ADPS0),
	adc_clkdiv_4 =   (0<<ADPS2) | (1<<ADPS1) | (0<<ADPS0),
	adc_clkdiv_8 =   (0<<ADPS2) | (1<<ADPS1) | (1<<ADPS0),
	adc_clkdiv_16 =  (1<<ADPS2) | (0<<ADPS1) | (0<<ADPS0),
	adc_clkdiv_32 =  (1<<ADPS2) | (0<<ADPS1) | (1<<ADPS0),
	adc_clkdiv_64 =  (1<<ADPS2) | (1<<ADPS1) | (0<<ADPS0),
	adc_clkdiv_128 = (1<<ADPS2) | (1<<ADPS1) | (1<<ADPS0),
}	adc_clkdiv_e;


// Register: ADCSRB
typedef enum
{
	adc_trig_freeRun  = (0<<ADTS2) | (0<<ADTS1) | (0<<ADTS0),
	adc_trig_anComp   = (0<<ADTS2) | (0<<ADTS1) | (1<<ADTS0),
	adc_trig_extInt0  = (0<<ADTS2) | (1<<ADTS1) | (0<<ADTS0),
	adc_trig_tmr0CmpA = (0<<ADTS2) | (1<<ADTS1) | (1<<ADTS0),
	adc_trig_tmr0Ovfl = (1<<ADTS2) | (0<<ADTS1) | (0<<ADTS0),
	adc_trig_tmr1CmpB = (1<<ADTS2) | (0<<ADTS1) | (1<<ADTS0),
	adc_trig_tmr2Ovfl = (1<<ADTS2) | (1<<ADTS1) | (0<<ADTS0),
	adc_trig_tmr1Capt = (1<<ADTS2) | (1<<ADTS1) | (1<<ADTS0),
}	adc_trig_e;


#endif /* M328P_H_ */